%Function dTdt used in EXAMPLE 3.8-2
function[dTdt]=dTdt_EX3p8d2(time,T,r,g_dot_sp,T_b,c_t,rho_t,beta)

    [N,g]=size(T);      %number of nodes
    DELTAr=r(2)-r(1);   %distance between nodes
    dTdt=zeros(N,1);    %initialize temperature rate of change vector
    dTdt(1)=g_dot_sp/(2*pi*r(1)^2*DELTAr*rho_t*c_t)...
        +2*(r(1)+DELTAr/2)^2*k_t((T(1)+T(2))/2)*(T(2)-T(1))/(r(1)^2*DELTAr^2*rho_t*c_t)...
        -beta*(T(1)-T_b)/(rho_t*c_t);
    for i=2:(N-1)
        dTdt(i)=(r(i)-DELTAr/2)^2*k_t((T(i)+T(i-1))/2)*(T(i-1)-T(i))/(r(i)^2*DELTAr^2*rho_t*c_t)...
            +(r(i)+DELTAr/2)^2*k_t((T(i)+T(i+1))/2)*(T(i+1)-T(i))/(r(i)^2*DELTAr^2*rho_t*c_t)...
            -beta*(T(i)-T_b)/(rho_t*c_t);
    end
    dTdt(N)=0;

end

function[k]=k_t(T)
    k=-0.621+6.03e-3*T-7.87e-6*T^2; %tissue conductivity
end